zoukankan      html  css  js  c++  java
  • HDU 4649 Professor Tian

    Professor Tian

    Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65535/32768 K (Java/Others)
    Total Submission(s): 376    Accepted Submission(s): 199

    Problem Description
    Timer took the Probability and Mathematical Statistics course in the 2012, But his bad attendance angered Professor Tian who is in charge of the course. Therefore, Professor Tian decided to let Timer face a hard probability problem, and announced that if he fail to slove the problem there would be no way for Timer to pass the final exam.
    As a result , Timer passed.
    Now, you, the bad guy, also angered the Professor Tian when September Ends. You have to faced the problem too. The problem comes that there is an expression and you should calculate the excepted value of it. And the operators it may contains are '&' (and),'|'(or) and '^'(xor) which are all bit operators. For example: 7&3=3, 5&2=0, 2|5=7, 4|10=14, 6^5=3, 3^4=7.
    Professor Tian declares that each operator O i with its coming number A i+1 may disappear, and the probability that it happens is P i (0<i<=n).
     
    Input
    The input contains several test cases. For each test case, there is a integer n (0<n<=200) in the first line.In the second line, there are n+1 integers, stand for {A i}. The next line contains n operators ,stand for {O i}. The forth line contains {P i}.
    A i will be less than 2 20, 0<=P i<=1.
     
    Output
    For each text case, you should print the number of text case in the first line.Then output the excepted value of the expression, round to 6 decimal places.
     
    Sample Input
    2 1 2 3 ^ ^ 0.1 0.2 2 8 9 10 ^ ^ 0.5 0.78 1 1 2 & 0.5
     
    Sample Output
    Case 1: 0.720000 Case 2: 4.940000 Case 3: 0.500000
     
    Source
     
    Recommend
    zhuyuanchen520
     贴一下解题报告的思路:
       

    反状态压缩——把数据转换成20位的01来进行运算

    因为只有20位,而且&,|,^都不会进位,那么一位一位地看,每一位不是0就是1,这样求出每一位是1的概率,再乘以该位的十进制数,累加,就得到了总体的期望。

    对于每一位,状态转移方程如下:

    f[i][j]表示该位取前i个数,运算得到j(01)的概率是多少。

    f[i][1]=f[i-1][1]*p[i]+根据不同运算符和第i位的值运算得到1的概率。

    f[i][0]同理。

    初始状态:f[0][0~1]=01(根据第一个数的该位来设置)

    每一位为1的期望 f[n][1]

    #include <iostream>
    #include <cstring>
    #include <cstdio>
    #include <cmath>
    #define N 250
    using namespace std;
    int num[N];
    double p[N],dp[N][2];
    char opr[N],s1[N];
    int main()
    {
        //freopen("data.in","r",stdin);
        int n,tem=1;
        char c1,c2;
        while(scanf("%d",&n)!=EOF)
        {
            for(int i=0;i<=n;i++)
            {
                scanf("%d",&num[i]);
            }
            getchar();
            gets(s1);
            int l = strlen(s1);
            for(int i=0,j=0;i<=l-1;i++)
            {
                if(s1[i]=='|'||s1[i]=='^'||s1[i]=='&')
                {
                    opr[j] = s1[i];
                    j++;
                }
            }
            for(int i=0;i<=n-1;i++)
            {
                scanf("%lf",&p[i]);
            }
            double ans=0.0;
            for(int i=1;i<=20;i++)
            {
                int t=num[0]&1;
                dp[0][t] = 1;
                dp[0][(t+1)%2] = 0;
                num[0]=(num[0]>>1);
                for(int j=1;j<=n;j++)
                {
                    int k = num[j]&1;
                    num[j]=(num[j]>>1);
                    char c = opr[j-1];
                    if(c=='|')
                    {
                        if(k==1)
                        {
                            dp[j][1] = dp[j-1][1]+dp[j-1][0]*(1-p[j-1]);
                            dp[j][0] = dp[j-1][0]*p[j-1];
                        }else
                        {
                            dp[j][1] = dp[j-1][1];
                            dp[j][0] = dp[j-1][0];
                        }
                        continue;
                    }else if(c=='&')
                    {
                        if(k==1)
                        {
                            dp[j][1] = dp[j-1][1];
                            dp[j][0] = dp[j-1][0];
                        }else
                        {
                            dp[j][1] = dp[j-1][1]*p[j-1];
                            dp[j][0] = dp[j-1][1]*(1-p[j-1])+dp[j-1][0];
                        }
                        continue;
                    }else if(c=='^')
                    {
                        if(k==1)
                        {
                            dp[j][1] = dp[j-1][0]*(1-p[j-1])+dp[j-1][1]*p[j-1];
                            dp[j][0] = dp[j-1][1]*(1-p[j-1])+dp[j-1][0]*p[j-1];
                        }else
                        {
                            dp[j][1] = dp[j-1][1];
                            dp[j][0] = dp[j-1][0];
                        }
                        continue;
                    }
                }
                ans += (1<<(i-1))*dp[n][1];
            }
            printf("Case %d:
    ",tem++);
            printf("%.6lf
    ",ans);
        }
        return 0;
    }
    


  • 相关阅读:
    cpp:博文_注意
    Algs4-1.2(非习题)String
    Algs4-1.2(非习题)几何对象中的一个2D用例
    Algs4-1.2.19字符串解析
    Algs4-1.2.18累加器的方差
    Algs4-1.2.17有理数实现的健壮性
    Algs4-1.2.16有理数
    Algs4-1.2.15基于String的split()的方法实现In中的静态方法readInts()
    Algs4-1.2.13实现Transaction类型
    Algs4-1.2.14实现Transaction中的equals()方法
  • 原文地址:https://www.cnblogs.com/riskyer/p/3243809.html
Copyright © 2011-2022 走看看